#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>

#define R 20000
#define r 0.8
#define F 1.0

int main(int argc, char *argv[])
{
	int i,j;
	int x,y;
	int max=0;
	int flag,Line;
	double s,t,u,v;
	
	int *ll,*lr,*filter;
	int *deg;
	double *PR1,*PR2;
	double *bunb;
	
	ll=(int *)calloc(1,sizeof(int));
	lr=(int *)calloc(1,sizeof(int));
	filter=(int *)calloc(1,sizeof(int));
	
	Line=1;
	max=0;
	
	FILE *fp;
	//argv[1] : list file to read
	fp=fopen(argv[1],"r");
	while(fscanf(fp,"%d %d",&x,&y)!=EOF)
	{
	max=maximum(max,x);
	max=maximum(max,y);
	ll=(int *)realloc(ll,(Line+1)*sizeof(int));
	lr=(int *)realloc(lr,(Line+1)*sizeof(int));
	ll[Line]=x;
	lr[Line]=y;
	Line++;
	}
	fclose(fp);
	//finish reading the list
	
	max++;
	deg=(int *)calloc(max,sizeof(int));
	filter=(int *)realloc(filter,(max+1)*sizeof(int));
	for(i=1;i<Line;i++)
	{
		filter[ll[i]]=1;
		filter[lr[i]]=1;
		deg[ll[i]]+=1;
	}

	PR1=(double *)calloc(max,sizeof(double));
	PR2=(double *)calloc(max,sizeof(double));
	
	////initial////
	
	for(i=1;i<max;i++)
	{
		if(filter[i]>0)
		{
		PR2[i]=1.0;  //if node i exits , initial = 1
		}
	}
	
	
	////update////

	for(j=0;j<R;j++)
	{
		/////clear/////
		flag=0;
	
	////update////
	for(i=1;i<Line;i++)
	{
		PR1[lr[i]]+=PR2[ll[i]]/deg[ll[i]];
	}
	
	for(i=1;i<max;i++)
	{
		if(filter[i]>0)
		{
		PR1[i]=r*PR1[i]+F;
		}
		if(fabs(PR1[i]-PR2[i])<0.01)
		{flag++;}
		
		PR2[i]=PR1[i];
		
		PR1[i]=0;
	}
	
	if(flag==max-1)
	{break;}
	}
	
	for(i=1;i<max;i++)
	{
		if(filter[i]>0)
		{
		printf("%d %f\n",i,PR2[i]);
		}
	}
	free(ll);
	free(lr);
	free(filter);
	free(PR1);
	free(PR2);
}

int maximum(int aa,int bb)
{
	if(aa>bb)
	{
		return(aa);
	}else{
		return(bb);
	}
}